/*
	avr-gcc -mmcu=atmega16 -Os -g -o testc.o -x c test.c
	avr-gcc -mmcu=atmega16 -Os -g -o testcpp.o -x c++ test.c
	avr-nm -S testc.o testcpp.o
 */
#include <stdint.h>
#include "CBUF.h"

#ifdef __cplusplus

CBUF< uint8_t, 64, uint8_t >  myQ;

#else

#define myQ_IndexType uint8_t
#define myQ_EntryType uint8_t
#define myQ_SIZE  64
CBUF_DECLARE(myQ);

#endif

int main(void)
{
	volatile uint8_t ch;

#ifdef __cplusplus

	myQ.Push('x');
	ch = myQ.Pop();

#else

	CBUF_Push( myQ, 'x' );
	ch = CBUF_Pop( myQ );

#endif

	return 0;
}
